﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_find_friday_13th
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Make the end date 10 years from now.
        private void Form1_Load(object sender, EventArgs e)
        {
            dtpEnd.Value = dtpStart.Value + new TimeSpan(365 * 10, 0, 0, 0);
        }

        // List Friday the 13ths between the start and end dates.
        private void btnGo_Click(object sender, EventArgs e)
        {
            lstResults.Items.Clear();

            // Get the start and end date components.
            DateTime start_date = dtpStart.Value.Date;
            DateTime end_date = dtpEnd.Value.Date;
            int start_year = start_date.Year;
            int end_year = end_date.Year;

            // Loop over the selected years.
            for (int year = start_year; year <= end_year; year++)
            {
                // Loop over the months in the year.
                for (int month = 1; month <= 12; month++)
                {
                    // See if this month's 13th is a Friday.
                    DateTime test_date = new DateTime(year, month, 13);

                    // If we haven't reached the start date, skip this one.
                    if (test_date < start_date) continue;

                    // If we've passed the end date, stop looping.
                    if (test_date > end_date) break;

                    // See if this is a Friday.
                    if (test_date.DayOfWeek == DayOfWeek.Friday)
                        lstResults.Items.Add(test_date.ToShortDateString());
                }
            }
        }
    }
}
